#{extends 'common/frontend-admin.html' /}
#{set 'title'}
<h1>Jawab Pertanyaan</h1>
#{/set}
<div class="container">
    <div class="row">
        <div class="col-sm-10">
            <div class="card">
                <div class="alert alert-danger alert-modal hidden"> </div>
                <div class="card-header">Daftar Pertanyaan yang belum dijawab:
                </div>
                <div class="card-body">
                    <form class="input-jawaban" id="input-jawaban" action=""  method="post">
                            #{list questions, as: 'question'}
                            <div class="form-group">
                                <div class="row">
                                    <label for="model.jawaban" class="col-sm-12 control-label">${question.pertanyaan.raw()}</label>
                                    <div class="col-sm-12 #{errorClass 'model.jawaban'/}">
                                        <input type="text" name="model.jawaban[]" id="model.jawaban" data-id="${question?.id}" data-attr="${question_index}" placeholder="Masukkan jawaban disini" class="form-control jawaban">
                                        <span class="help-block">#{error 'model.jawaban' /}</span>
                                    </div>
                                </div>
                            </div>
                            #{/list}
                        <div class="form-group">
                            <div class="row" style="justify-content:center;">
                                <button type="button" class="btn btn-success save-button"><i class="fa fa-save"></i> Simpan Jawaban</button>
                                &nbsp;&nbsp;
                                <a href='#{url route.user_management_usercontroller_index /}' class="btn btn-warning"><i class="fa fa-arrow-circle-left"></i> Kembali</a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
#{set 'moreStyles'}
<style>
.form-group label:not(.error){padding: 7px!important;}
.modal-open .select2-container{z-index:0!important;}
.card .card-body {padding: 20px!important;}
</style>
#{/set}
#{set 'moreScripts'}
<script type="text/javascript" src="@{'public/javascripts/jquery.blockui.js'}"></script>
<script type="text/javascript">
    $(document).ready(function() {

        function blockPageUI() {
        $.blockUI({ message: '<h2><img src="@{'public/images/busy2.gif'}" width="50" height="50" /> Please Wait ....</h2>',
        baseZ: 2000 ,css: { backgroundColor: '#00000000', color: '#fff', border: "0px"}});
        }

        function unblockPageUI() {
            $.unblockUI();
        }

        function generateDataForm() {
            var data = new FormData($('#input-jawaban')[0]);
            data.delete("model.pertanyaanId[]");
            data.delete("model.jawaban[]");
            var tagsJawaban = new Array();
            var tagsPertanyaan = new Array();
            $("input[name='model.jawaban[]']").each(function() {
                jawaban = $(this).val();
                jawaban == "" ? jawaban = " " : jawaban;
                pertanyaanID = $(this).data("id");
                tagsJawaban.push(jawaban);
                tagsPertanyaan.push(pertanyaanID);
            });
            data.append('model.jawaban[]', tagsJawaban);
            data.append('model.pertanyaanId[]', tagsPertanyaan);
            return data;
        }

        function submitAnswer() {
            var data = generateDataForm();
            $.ajax({
                xhr: function() {
                        var browser = navigator.appName;
                        if(browser == "Microsoft Internet Explorer"){
                            var xhr = new window.ActiveXObject("Microsoft.XMLHTTP");
                        } else {
                            var xhr = new window.XMLHttpRequest();
                        }
                        xhr.upload.addEventListener("progress", function(evt) {
                        if (evt.lengthComputable) {
                            var percentComplete = (evt.loaded / evt.total) * 100;
                        }
                    }, false)

                    return xhr
                },
                async:true,
                type: "POST",
                cache: false,
                contentType: false,
                processData: false,
                url: "#{url route.questionanswers_questionapicontroller_storeanswerquestion /}",
                data: data,
                beforeSend: function(){blockPageUI();},
                success: function(result){
                    console.log(result);
                    if (result.status){
                       $('.alert-modal').removeClass('hidden')
                            .removeClass('alert-danger')
                            .addClass('alert-success')
                            .html(result.message);
                       setTimeout(function(){window.location.href = result.payload}, 1000);
                    } else {
                        $('.alert-modal')
                                .addClass('alert-danger')
                                .removeClass('alert-success')
                                .removeClass('hidden').html(result.message);
                    }
                },
                complete: function(){unblockPageUI();},
                error: function(){
                    unblockPageUI();
                    $('.alert-modal')
                            .addClass('alert-danger')
                            .removeClass('alert-success')
                            .removeClass('hidden').html('&{translation.general_error}');
                }
            });
        }
        $('.save-button').click(function(e) {
            e.preventDefault();
            submitAnswer();
        })
    });
</script>
#{/set}